<script setup>
import {ref} from 'vue';
import {useAuthenticationStore} from "@/stores/authenticationStore.js";
import {useRouter} from "vue-router";


const router = useRouter();

const loginStore = useAuthenticationStore();
const apiError = ref('');
const email = ref('');
const password = ref('');

async function loginUser() {
  apiError.value = '';

  try {
    await loginStore.login({email: email.value, password: password.value});
    router.push('/mainApp');
  } catch (err) {
    if (err.isAxiosError && err.response.status === 400) {
      apiError.value = "Email address does not have a valid format or the password is shorter than eight characters";

    } else if (err.isAxiosError && err.response.status === 401) {
      apiError.value = "Email address or password is not correct";

    } else {
      apiError.value = "Unknown error occurred";
    }
    console.log(apiError.value);
  }
}

const navigateToRegister = () => {
  router.push('/register')

};
</script>

<template>
  <v-container fill-height fluid class="pa-0">
    <v-row justify="center" align="center" class="login-row">
      <v-col cols="12" sm="8" md="4">
        <v-card class="elevation-12 pa-5" color="#FFFFFF">
          <v-toolbar color="indigo-darken-1" dark flat>
            <v-toolbar-title>Login</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form @submit.prevent="loginUser">
              <v-text-field label="E-Mail" v-model="email" outlined dense></v-text-field>
              <v-text-field label="Password" type="password" v-model="password" outlined dense></v-text-field>
              <v-btn color="indigo-darken-1" dark class="mt-5" block type="submit">Login</v-btn>
              <v-btn color="grey" dark class="mt-3" @click="navigateToRegister" id="registerBtn">Register</v-btn>
            </v-form>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
.login-row {
  min-height: 100vh;
  background: url('https://images.unsplash.com/photo-1523634921619-37ce98c1877f?q=80&w=2073&auto=format&fit=crop&ixlib=rb-4.0.3&ixid=M3wxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8fA%3D%3D') center/cover no-repeat;
}

.v-card {
  max-width: 400px;
  margin-top: -100px; /* Adjust or remove this based on your design preference */
}

@media (max-height: 800px) {
  .v-card {
    margin-top: 0px;
  }
}

#registerBtn{
  opacity: 80%;
}
</style>